#ifndef _IDJVU_
#define _IDJVU_

#ifndef PLUGIN_LOADER

#include <libdjvu/ddjvuapi.h>

//#include "../gloobus-preview-plugin-manager.h"
#include "../gloobus-preview-interface-document.h"

class iDjvu : public iDocument
{
	private:
		ddjvu_context_t		*	d_context;
		ddjvu_document_t	*	d_document;
		ddjvu_format_t		*	d_format;
		int						d_page_width;
		int						d_page_height;
		double					d_page_scale;

	public:
							iDjvu			( void );
		virtual				~iDjvu			( void );
		virtual	int			get_n_pages		( void );
		virtual	int			get_page_width	( void );
		virtual	int			get_page_height	( void );
		virtual	GdkPixbuf*	get_page_pixbuf	( int n_page );
		virtual	GtkWidget*	get_page		( int );
		virtual	void		end_plugin		( void );
		virtual	bool		load_doc		( void );

				int			get_page_height_unscaled	( void );
				int			get_page_width_unscaled		( void );

	private:
				void		get_page_size	(gint, int*, int*);
				void		wait_for_message(ddjvu_message_tag_t, GError**);
				void		handle_message	(const ddjvu_message_t*, GError**);
				void		handle_events	(int, GError**);
				void		get_page_scale	( void );
};


extern "C" interface * create() {
    return new iDjvu;
}

extern "C" void destroy(interface * p) {
    delete (iDjvu*)p;
}

extern "C" int getVersion() {
	return MANAGER_VERSION;
}

#endif

#ifdef PLUGIN_LOADER

PluginManager::register_plugin("djvu");

PluginManager::register_filetype("image/vnd.djvu", 1);

#endif

#endif

